# Generated by sila2.code_generator; sila2.__version__: 0.10.5
# -----
# This class does not do anything useful at runtime. Its only purpose is to provide type annotations.
# Since sphinx does not support .pyi files (yet?), this is a .py file.
# -----

from __future__ import annotations

from typing import TYPE_CHECKING

if TYPE_CHECKING:
    from typing import Iterable, Optional

    from lightintensitycontroller_types import ControlLightIntensity_Responses
    from sila2.client import ClientMetadataInstance, ClientObservableCommandInstance, ClientObservableProperty


class LightIntensityControllerClient:
    """

    This is a simple example of a generic Feature for controlling and retrieving the LightIntensity.
    A new target LightIntensity can be set anytime with the 'Control LightIntensity' Command.
    The LightIntensity range has been limited to prevent major damages of a device.
    In case the first target LightIntensity has not been reached, a ControlInterrupted Error should be thrown.

    """

    CurrentLightIntensity: ClientObservableProperty[float]
    """
    The current Light Intensity as measured by the controller.
    """

    def ControlLightIntensity(
        self, TargetLightIntensity: float, *, metadata: Optional[Iterable[ClientMetadataInstance]] = None
    ) -> ClientObservableCommandInstance[ControlLightIntensity_Responses]:
        """

        Control the LightIntensity gradually to a set target.
        It is RECOMMENDED to use an oscillation free control system.

        """
        ...
